;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Loading and Rotating images
;; Developed by: Krylar (with ideas from Insectoids)
;; Last Revision: 10/11/2000
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Initialize BB to run at 800x600
Graphics 800,600

Const iNumRotations=36               ;how many rotations do we want?

Dim imgShipFrames(iNumRotations)     ;Holds the rotated images

Global iCurrentFrame = 0             ;What is the current frame being displayed?

; tell BB to handle the centering of our images
AutoMidHandle True

; Load the player image and point to it with "imgTemp"
imgTemp = LoadImage("graphics\player.bmp")

; See if the image was loaded successfully (the "imgTemp" will be 0 if not)
If imgTemp = 0 Then
   Text 100,100,"Invalid Image!"    ; tell the user it was invalid if 0
Else

   ; set it's mask (transparent color)
   MaskImage imgTemp,0,0,0

   ; now run through the loop and rotate the image
   For iLoop=0 To iNumRotations-1

       ; first let's copy the original image into the current frame
   	   imgShipFrames(iLoop)=CopyImage( imgTemp )

       ; then rotate that frame the appropriate number of degrees
	   RotateImage imgShipFrames(iLoop),iLoop*360/iNumRotations
   Next
EndIf


; loop until the player hits the ESC key
While Not KeyHit(1)

  ; clear the screen
  Cls

  ; display the current Ship Frame in the center of the screen
  DrawImage(imgShipFrames(iCurrentFrame),400,300)

  ; change the current frame (spin it to the right)
  iCurrentFrame = iCurrentFrame + 1

  ; if the current frame counter goes past our number of
  ; allowable rotations, reset it to 0
  If iCurrentFrame > iNumRotations - 1
     iCurrentFrame = 0
  EndIf

  ; delay for 50 milliseconds so we can see the animation
  Delay 50 

Wend
  
; end the program, return control to Windows
End
