;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Parallaxing starfields
;; Developed by: Krylar (with ideas from Insectoids)
;; Last Revision: 10/11/2000
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; Initialize BB to run at 800x600
Graphics 800,600

; set up the drawing buffer to be the backbuffer
SetBuffer BackBuffer()

; load up the star backgrounds (3 total)
imgStarsFar=LoadImage( "graphics\starsfar.bmp" )
imgStarsMid=LoadImage( "graphics\starsmid.bmp" )
imgStarsClose=LoadImage( "graphics\stars.bmp" )

; create a variable to keep track of our drawing locations
Global iStarsScroll

; loop until the player hits the ESC key
While Not KeyHit(1)

  ; clear the screen/buffer
  Cls

  ; Fill the whole background with the 3 star layers
  ; in their current positions
  TileBlock imgStarsFar,0,iStarsScroll
  TileImage imgStarsMid,7,iStarsScroll*2
  TileImage imgStarsClose,23,iStarsScroll*3

  ; calculate the new position to start the next drawing cycle
  iStarsScroll=(iStarsScroll+1) Mod ImageHeight( imgStarsFar )

  ; flip the back drawing buffer to the display
  Flip
Wend
  
; end the program, return control to Windows
End