;***************************************************************************
;* ZOrder Demo
;*     Coded By: Krylar
;* Last Updated: 11/22/2000
;***************************************************************************

; setup our graphics mode
Graphics 640,480

; set the Backbuffer as the drawing surface
; for page flipping
SetBuffer BackBuffer()

; load up our dummy images
Wall_Image = LoadImage("graphics\walltile.bmp")
Stoop_Image = LoadImage("graphics\stoop1.bmp")
Knight_Image = LoadImage("graphics\knight.bmp")

; create a type that has which image to use, where
; to draw it, a direction to show the ZOrdering in
; action, and the ZOrder of the image
Type Images
 Field ImageToUse
 Field X,Y
 Field iDir
 Field ZOrder
End Type

; create an instance of the Images Object, starting it
; moving from right to left, and starting it
; as being "behind" the baseline plane.  Make this
; one the "wall" (or big blue square)
NewImage.Images = New Images
NewImage\ImageToUse = 0
NewImage\X = 125
NewImage\Y = 100
NewImage\iDir = -1
NewImage\ZOrder = -1

; create an instance of the Images Object, no movement, 
; And starting it as being ON the baseline plane.  
; Make this one the "Knight" image
NewImage.Images = New Images
NewImage\ImageToUse = 1
NewImage\X = 100
NewImage\Y = 100
NewImage\iDir = 0
NewImage\ZOrder = 0

; create an instance of the Images Object, moving from
; left to right, and starting it as being "In Front of" 
; the baseline plane. Make this one the the little rock
; image
NewImage.Images = New Images
NewImage\ImageToUse = 2
NewImage\X = 75
NewImage\Y = 100
NewImage\iDir = 1
NewImage\ZOrder = 1


; quit only if the user hits ESC
While Not KeyHit(1)

 ; clear the screen
 Cls

 ; Use this FOR...NEXT loop to cover each ZOrder plane of
 ; drawing.  So, if we're at -1, that will be the bottom. 
 ; 0 will be the middle (or baseline), and 1 will be the top.
 For Planes = -1 To 1

     ; run through each of our images
     For NewImage.Images = Each Images

         ; see if the current image is on the Plane we're on
         If NewImage\ZOrder = Planes

            ; if so, see what image we need to draw
            Select NewImage\ImageToUse

                   ; it's the wall image
                   Case 0        
                        DrawImage(Wall_Image,NewImage\X,NewImage\Y)

                        ; this is just for looks, but it moves the
                        ; wall back and forth
                        Select NewImage\iDir
                               Case 1
                                    NewImage\X = NewImage\X + 1
                                    If NewImage\X > 125
                                       NewImage\iDir = -1
                                    EndIf 
                               Case -1
                                    NewImage\X = NewImage\X - 1
                                    If NewImage\X < 75
                                       NewImage\iDir = 1
                                    EndIf 
                        End Select

                   ; it's the Knight image
                   Case 1
                        DrawImage(Knight_Image,NewImage\X,NewImage\Y)

                   ; it's the rock image
                   Case 2
                        DrawImage(Stoop_Image,NewImage\X,NewImage\Y)

                        ; this is just for looks, but it moves the
                        ; rock back and forth
                        Select NewImage\iDir
                               Case 1
                                    NewImage\X = NewImage\X + 1
                                    If NewImage\X > 125
                                       NewImage\iDir = -1
                                    EndIf 
                               Case -1
                                    NewImage\X = NewImage\X - 1
                                    If NewImage\X < 75
                                       NewImage\iDir = 1
                                    EndIf 
                        End Select
            End Select
         EndIf
     Next
 Next

 ; put up a little text telling the user how to change the ordering
 Text 0,300,"Press the spacebar to change the ZOrder"

 ; if the user hits the spacebar
 If KeyHit(57)
    ; run through the image list again
    For NewImage.Images = Each Images

        ; determine the ZOrder value and change it accordingly
        ; -1 will change to 1, 0 to -1, and 1 to 0...again, this
        ; is just so the user can see it in action
        Select NewImage\ZOrder
               Case -1
                     NewImage\ZOrder = 1
               Case 0
                     NewImage\ZOrder = -1
               Case 1
                     NewImage\ZOrder = 0
        End Select
    Next
 EndIf

 ; flip the pages so the user will see the animation's effect
 Flip
Wend

; end the program
End



